# Python-Intro
Eine einfach gehaltene Einführung in die Phyton Syntax zum lernen oder nachschlagen.

Gerade im Aufbau ist noch nichts groß sortiert, sondern erstmal in eine Reihenfolge zum erlernen gebracht.

Letztendlich soll ein kleines Cheatsheet entstehen, das als schnelles Nachschlagwerk und zum lernen benutzt werden kann.

Wir nutzen JupyterNotebooks: Nach dem Code-Block ist jeweils die Konsolen-Ausgabe sichtbar.

## Inhaltsverzeichnis
 1. Grundlagen
    - Grundrechenarten
    - Datentypen 
       1. Zahlen
       2. Strings
       3. Boolean
       4. Variable
       5. Kommentare
    - Grundfunktionen
       1. print
       2. input
       3. len
       4. join
 2. Datenstrukturen
    - Listen
    - Dictionaries
    - Tupel
    - Set
    - PriorityQueue
 3. Daten(-strukturen) umwandeln
 4. Operatoren & Gatter
 5. Schleifen 
     - if
     - for
     - while
 6. Funktionen
 7. Dateien 
     - schreiben
     - lesen
 8. Module 
     - eigene Erstellen
     - bestehende importieren
 9. Generatoren
 10. Objektorientierung
 11. Exceptions

Fange direkt an: [Start](Python-Syntax.ipynb)

Du hast Fragen oder Verbesserungsvorschläge? Dann schreib mich an oder starte ein Issue.

## Startpunkte für Python
- die Python [Dokumentation](https://docs.python.org/3/)
    - Hier ist alles ausführlich aufgeführt und beschrieben. Viele Informationen und Tipps
- Python Üben/Markup mit [Anaconda](http://anaconda.com)
    - Anaconda Jupyter Launcher ist sehr nützlich um Notebooks zu erstellen. Code und Markup können so zusammen in einem Dokument geschrieben werden
- Programmierumgebung (IDE) [pycharm](https://www.jetbrains.com/pycharm/)
    - PyCharm ist eine hervorragende IDE um eigene Python-Programme zu erstellen (für Studenten/Lehrer kostenlos)

## Wie geht man bei Fehlern vor?
- Variablen überprüfen (alles richtig definiert? Groß-/Kleinschreibung beachtet?)
- Klammern nicht vergessen bzw. richtige Klammern(reihenfolge) gesetzt {[()]}
- Syntax: Einrückungen richtig gesetzt? Zeilenumbrüche nicht vergessen?
- [Stackoverflow](http://www.stackoverflow.com) oder (Suchmaschinen)[http://duckduckgo.de]; irgendjemand hatte deinen Fehler bestimmt schon mal ;)
- Fehler sind normal und kommen vor, mach dir nichts draus. Mit genügend Übung werden Fehler weniger und weniger

# Specials und Übungen
Während ich an dem Cheatsheet arbeite und kleine Programme schreibe, bin ich auch dabei kleine Einführungen zu diversen Spezialisierteren Themen zu erstellen. Diese werden ebenfalls in diesem Repository festgehalten.

## Body Mass Index berechnen
Einfaches Python Programm, das Körpergewicht und Körpergröße abfrägt um daraus den BMI zu berechnen und auszugeben: [BMI.py](uebung/bmi.py)


## Webcrawling
Im  [Web Crawling](Web%20Crawling.ipynb) (.html oder .ipynb) sind die Grundlagen zum Auslesen von Webseiten festgehalten.

## FLASK
**coming soon**

## CSV Dateien erstellen/bearbeiten
**coming soon**


## Bildverarbeitung
**coming soon**

## Künstliche Intelligenz (KI/AI)
**coming soon**

